Mojolicious::Command(3)

NAME
Mojolicious::Command - Command base class

SYNOPSIS
  # Lowercase command name
  package Mojolicious::Command::mycommand;
  use Mojo::Base 'Mojolicious::Command';

  # Short description
  has description => 'My first Mojo command';

  # Usage message from SYNOPSIS
  has usage => sub { shift->extract_usage };

  sub run {
    my ($self, @args) = @_;

    # Magic here! :)
  }

  1;

  =head1 SYNOPSIS

    Usage: APPLICATION mycommand [OPTIONS]

    Options:
      -s, --something   Does something

  =cut

DESCRIPTION
Mojolicious::Command is an abstract base class for Mojolicious commands.

See "COMMANDS" in Mojolicious::Commands for a list of commands that are available by default.

ATTRIBUTES
Mojolicious::Command implements the following attributes.

  app
  my $app  = $command->app;
  $command = $command->app(Mojolicious->new);

Application for command, defaults to a Mojo::HelloWorld object.

  # Introspect
  say "Template path: $_" for @{$command->app->renderer->paths};

  description
  my $description = $command->description;
  $command        = $command->description('Foo');

Short description of command, used for the command list.

  quiet
  my $bool = $command->quiet;
  $command = $command->quiet($bool);

Limited command output.

  usage
  my $usage = $command->usage;
  $command  = $command->usage('Foo');

Usage information for command, used for the help screen.

METHODS
Mojolicious::Command inherits all methods from Mojo::Base and implements the following new ones.

  chmod_file
  $command = $command->chmod_file('/home/sri/foo.txt', 0644);

Change mode of a file.

  chmod_rel_file
  $command = $command->chmod_rel_file('foo/foo.txt', 0644);

Portably change mode of a file relative to the current working directory.

  create_dir
  $command = $command->create_dir('/home/sri/foo/bar');

Create a directory.

  create_rel_dir
  $command = $command->create_rel_dir('foo/bar/baz');

Portably create a directory relative to the current working directory.

  extract_usage
  my $usage = $command->extract_usage;

Extract usage message from the SYNOPSIS section of the file this method was called from with "extract_usage" in Mojo::Util.

  help
  $command->help;

Print usage information for command.

  rel_file
  my $path = $command->rel_file('foo/bar.txt');

Return a Mojo::File object relative to the current working directory.

  render_data
  my $data = $command->render_data('foo_bar');
  my $data = $command->render_data('foo_bar', @args);

Render a template from the "DATA" section of the command class with Mojo::Loader and Mojo::Template.

  render_to_file
  $command = $command->render_to_file('foo_bar', '/home/sri/foo.txt');
  $command = $command->render_to_file('foo_bar', '/home/sri/foo.txt', @args);

Render a template from the "DATA" section of the command class with Mojo::Template to a file and create directory if necessary.

  render_to_rel_file
  $command = $command->render_to_rel_file('foo_bar', 'foo/bar.txt');
  $command = $command->render_to_rel_file('foo_bar', 'foo/bar.txt', @args);

Portably render a template from the "DATA" section of the command class with Mojo::Template to a file relative to the current working directory and create directory if necessary.

  run
  $command->run;
  $command->run(@ARGV);

Run command. Meant to be overloaded in a subclass.

  write_file
  $command = $command->write_file('/home/sri/foo.txt', 'Hello World!');

Write text to a file and create directory if necessary.

  write_rel_file
  $command = $command->write_rel_file('foo/bar.txt', 'Hello World!');

Portably write text to a file relative to the current working directory and create directory if necessary.

SEE ALSO
Mojolicious, Mojolicious::Guides, <http://mojolicious.org>.